/********************************************************************
 *	C֐    荞݃xN^[̐ݒ.
 ********************************************************************
 */
#include "GenericTypeDefs.h"
#include "Compiler.h"
#include "usb_config.h"
#include "./USB/usb_device.h"
#include "./USB/usb.h"
#include "./USB/usb_function_cdc.h"
#include "HardwareProfile.h"
#include "eusart.h"


void YourHighPriorityISRCode();
void YourLowPriorityISRCode();


/**	VECTOR REMAPPING ***********************************************/
#if	1
	#define	REMAPPED_RESET_VECTOR_ADDRESS			0x2a00
	#define	REMAPPED_HIGH_INTERRUPT_VECTOR_ADDRESS	0x2b08
	#define	REMAPPED_LOW_INTERRUPT_VECTOR_ADDRESS	0x2b18
#endif

#if	0
	#define	REMAPPED_RESET_VECTOR_ADDRESS			0x800
	#define	REMAPPED_HIGH_INTERRUPT_VECTOR_ADDRESS	0x808
	#define	REMAPPED_LOW_INTERRUPT_VECTOR_ADDRESS	0x818
#endif

#if	0
	#define	REMAPPED_RESET_VECTOR_ADDRESS			0x00
	#define	REMAPPED_HIGH_INTERRUPT_VECTOR_ADDRESS	0x08
	#define	REMAPPED_LOW_INTERRUPT_VECTOR_ADDRESS	0x18
#endif

/********************************************************************
 *	0x800`̃WvxN^[ݒ肷.
 ********************************************************************
 *	0x800 goto _startup
 *	0x808 goto YourHighPriorityISRCode
 *	0x818 goto YourLowPriorityISRCode
 */

extern void	_startup (void);		// See c018i.c in your C18 compiler	dir
#pragma	code REMAPPED_RESET_VECTOR = REMAPPED_RESET_VECTOR_ADDRESS
void _reset	(void)
{
	_asm goto _startup _endasm
}


#pragma	code REMAPPED_HIGH_INTERRUPT_VECTOR	= REMAPPED_HIGH_INTERRUPT_VECTOR_ADDRESS
void Remapped_High_ISR (void)
{
	 _asm goto YourHighPriorityISRCode _endasm
}


#pragma	code REMAPPED_LOW_INTERRUPT_VECTOR = REMAPPED_LOW_INTERRUPT_VECTOR_ADDRESS
void Remapped_Low_ISR (void)
{
	 _asm goto YourLowPriorityISRCode _endasm
}

/********************************************************************
 *	0x008`̃WvxN^[ݒ肷.
 ********************************************************************
 *	0x008 goto 0x808
 *	0x018 goto 0x818
 */
#pragma	code HIGH_INTERRUPT_VECTOR = 0x08
void High_ISR (void)
{
	 _asm goto REMAPPED_HIGH_INTERRUPT_VECTOR_ADDRESS _endasm
}


#pragma	code LOW_INTERRUPT_VECTOR =	0x18
void Low_ISR (void)
{
	 _asm goto REMAPPED_LOW_INTERRUPT_VECTOR_ADDRESS _endasm
}

/********************************************************************
 *	WvxN^[ݒ͂܂.
 ********************************************************************
 */


#pragma	code
/********************************************************************
 *	High荞ݏ֐.
 ********************************************************************
 */
#pragma	interrupt YourHighPriorityISRCode
void YourHighPriorityISRCode()
{
#if	USART_USE_INTERRUPT			// 荞݂gp.
	USART_RxIntHandler();
#endif

#if	defined(USB_INTERRUPT)
	USBDeviceTasks();
#endif

}	//This return will be a	"retfie fast", since this is in	a #pragma interrupt	section	

/********************************************************************
 *	Low 荞ݏ֐.
 ********************************************************************
 */
#pragma	interruptlow YourLowPriorityISRCode
void YourLowPriorityISRCode()
{

#if	USART_USE_INTERRUPT			// 荞݂gp.
#if	USART_USE_TX_INTERRUPT			// 荞݂gp.
	USART_TxIntHandler();
#endif
#endif

}	//This return will be a	"retfie", since	this is	in a #pragma interruptlow section 




#pragma	code

#if RAM_SERIAL	/* Add by senshu */
/*
  EEPROM MAP

	0x00i[Üj
	@:
	0xefi[Üj

	0xf0 VAԍ̑iiKł́A4Ɍj
	0xf1 VAԍi1ځj
	0xf2 VAԍi2ځj
	0xf3 VAԍi3ځj
	0xf4 VAԍi4ځj
	0xf5 VAԍi5ځj
	0xf6 VAԍi6ځj
	0xf7 \
	 :
	0xfc \
	0xfd USBVȀ{[[g
	0xfe DTR/RTSȂǂ̗LE̎wȂ
	0xff JUMPAhX(H) .... Av̏8rbgw
	ʂ 0x00z
 */
#define EE_SERIAL_LEN 0xf0
#define EE_SERIAL_TOP 0xf1


unsigned char ReadEE(unsigned char Address)
{
	EECON1 = 0x00;
	EEADR = Address;
	EECON1bits.RD = 1;
	return (EEDATA);
}

void set_serial_number()
{
	unsigned char ch;
	int i, j;
	if (ReadEE(EE_SERIAL_LEN) == 4) {
		/* f[^̑Ó */
		j = 0;
		for (i = EE_SERIAL_TOP; i < EE_SERIAL_TOP + 4; i++) {
			ch = ReadEE(i);
			if (' ' <= ch && ch <= 'z') {
				j++;
			}
		}
		/* f[^Ół΁AlZbg */
		if (j == 4) {
			for (i = 0; i < 4; i++) {
				sd003.string[i] = ReadEE (EE_SERIAL_TOP + i);
			}
		}
	}
}

#if 0
void WriteEE(unsigned char Address, unsigned char Data)
{
	EEADR = Address;
	EEDATA = Data;
	EECON1 = 0b00000100;	// Setup writes: EEPGD=0,WREN=1
	/* Start Write */
	EECON2 = 0x55;
	EECON2 = 0xAA;
	EECON1bits.WR = 1;
	while( EECON1bits.WR);	// Wait till WR bit is clear, hopefully not long enough to kill USB
}
#endif

#endif

/********************************************************************
 *
 ********************************************************************
 */
static void	InitializeSystem(void)
{
	extern void InitializeUSART(void);

#if RAM_SERIAL
	set_serial_number();
#endif
	ADCON1 |= 0x0F;					// Default all pins	to digital
	InitializeUSART();
	mInitAllLEDs();
	USBDeviceInit();
}
/********************************************************************
 *
 ********************************************************************
 */
void main(void)
{
	extern void ProcessIO(void);

	InitializeSystem();
	while(1){
#if	defined(USB_POLLING)
		USBDeviceTasks();
#endif
		ProcessIO();		
	}
}
/********************************************************************
 *
 ********************************************************************
 */
